/*
 * QUSOFT MICROSYSTMES
 * Power Basic
 * Copyright 2004 Frdric Brown
 */

/*
 *  This file is part of Power Basic library.
 *
 *  Power Basic library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Power Basic library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Power Basic library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __FUNCTIONS_HEADER__
#define __FUNCTIONS_HEADER__

#include "Variant.h"

#define ABS(n) abs(n)

Variant AUGMENT ( Variant l1, Variant l2 ) ;

#define CEILING(n) ceil(n)

Variant CHAR (short n) ;

#define COS(n) cos(n)
#define ACOS(n) acos(n)
#define COSH(n) cosh(n)
#define ACOSH(n) acosh(n)

long COLDIM (Variant v) ;

long COLNORM (Variant v) ;

Variant CUMSUM (Variant m) ;

long DIM (Variant v) ;

double DOTP (Variant v1, Variant v2) ;

double EXPR (Variant v) ;

#define FLOOR(n) floor(n)

Variant LEFT(Variant s, long n) ;

Variant FORMAT(Variant e, Variant t) ;

Variant FPART(Variant v) ;

Variant GCD(Variant v1, Variant v2) ;

Variant GETFOLD() ;

#define GETKEY() ngetchx()

Variant IDENTITY(Variant m, short size) ;

long INSTRING(Variant str, Variant sub, long b) ;

#define INT(n) FLOOR(n)

Variant INTDIV(Variant m1, Variant m2) ;

Variant LCM(Variant v1, Variant v2) ;

#define LN(n) log(n)

#define LOG(n) log10(n)

Variant MAT_LIST(Variant m) ;

//Variant MAX(Variant v1, Variant v2) ;
#define MAX(n1, n2) max(n1, n2)

double MEAN(Variant m) ;

double MEDIAN(Variant m) ;

Variant MID(Variant s, long b, long n) ;

#define MIN(n1, n2) min(n1, n2)

#define MOD(n1, n2) (n1 % n2)

Variant MROW(double expr, Variant m, short numL) ;

Variant MROWADD(double expr, Variant m, short numL1, short numL2) ;

long NCR(long n, long r) ;

double NORM(Variant m) ;

long NPR(long n, long r) ;

short ORD(Variant s) ;

double product(Variant m) ;

//BOOL ptTest(short x, short y) ;
#define PTTEST(x,y) getPix(x, y)

Variant PXLTEST(Variant l1, Variant l2) ;

double RAND(short n) ;

Variant RANDMAT(Variant m, short nbL, short nbC) ;

Variant REMAIN(Variant m1, Variant m2) ;

Variant RIGHT(Variant s, long n) ;

#define ROUND(n) round14(n)

Variant STOMAT (Variant m1, Variant m2) ;

#define STRING(v) asVariantString(v)

#endif