/*
 * QUSOFT MICROSYSTMES
 * Power Basic
 * Copyright 2004 Frdric Brown
 */

/*
 *  This file is part of Power Basic library.
 *
 *  Power Basic library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Power Basic library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Power Basic library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __PROCEDURES_HEADER__
#define __PROCEDURES_HEADER__

#include "Variant.h"

#define CIRCLE(x,y,r,o) DrawClipEllipse (x, y, r, r, ScrRect, convertAttr(o))

#define PXLCRCL(y,x,r,o) CIRCLE (x,y,r,o)

#define LINEHORZ(y, o) DrawLine(0, y, LCD_WIDTH - 1, y, convertAttr(o))
#define LINEVERT(x, o) DrawLine(x, 0, x, LCD_HEIGHT - 1, convertAttr(o))

#define PXLHORZ(y, o) LINEHORZ(y, o)
#define PXLVERT(x, o) LINEVERT(x, o)

#define PXLLINE(y0,x0,y1,x1,o) LINE(x0, y0, x1, y1, o)

#define RANDSEED(s) (s ? srand((unsigned long int)s) : randomize())

void SHELL (Variant v) ;

#define CLRDRAW() cmd_clrdraw()
#define CLRERR() cmd_clrerr()
#define CLRGRAPH() cmd_clrgraph()
#define CLRHOME() cmd_clrhome()
#define CLRIO() cmd_clrio()
#define CLRSCR() clrscr()
#define CLRTABLE() cmd_clrtable()

#define CUSTMON() cmd_custmon()
#define CUSTMOFF() cmd_custmoff()

#define DISPHOME() cmd_disphome()
#define DISPG()   cmd_dispg()  
#define DISPTBL() cmd_disptbl() 

void FILL (Variant e, Variant m) ;

#define OUTPUT(r, c, v) MoveTo(c,r); printVariant(v)

#define ANDPIC(v, y, x) PUTPIC (v, x, y, A_AND)
#define XORPIC(v, y, x) PUTPIC (v, x, y, A_XOR)
#define RCLPIC(v, y, x) PUTPIC (v, x, y, A_OR)
#define RPLCPIC(v, y, x) PUTPIC (v, x, y, A_REPLACE)

void PUTPIC (Variant v, short x, short y, short attr) ;

void COPYVAR (Variant v1, Variant v2) ;

void CYCLEPIC (Variant v, short nbImg, double del, short nbC, short dir) ;

void DELFOLD (Variant v) ;

void DELVAR (Variant v) ;

#define LINE(x0, y0, x1, y1, o) DrawLine (x0, y0, x1, y1, convertAttr(o)); 

void EXEC (Variant v) ;

void GET (Variant v) ;

void GETCALC (Variant v) ;

void SEND (Variant v) ;

void GETCALC (Variant v) ;

#define LOCK(v) setLocked(v, TRUE)

void MOVEVAR (Variant name, Variant src, Variant dest) ;

void NEWFOLD (Variant v) ;

void NEWPIC (Variant m, Variant v, short maxX, short maxY) ;

#define PXLCHG(y,x) PXLSET(x, y, A_XOR)
#define PXLOFF(y,x) PXLSET(x, y, A_REVERSE)
#define PXLON(y,x) PXLSET(x, y, A_NORMAL)

void PXLTEXT (Variant s, short y, short x) ; 

void RCLGDB(Variant v) ;

void PXLSET (Variant x, Variant y, short o) ;

char getFontWidth() ;
char getFontHeight() ;

#define REDIM(m, r, c) redimArray(m, r, c)

void RENAME (Variant v1, Variant v2) ;

#define SHOWSTAT() cmd_showstat() 

void STOGDB(Variant v) ;

void SORTA (Variant v) ;

void SORTD (Variant v) ;

void STOPIC (Variant v, short y, short x, short w, short h) ;

void TEXT (Variant message) ;

#define TRACE() trace()

void setLocked (Variant v, short b);

#define UNLOCK(v) setLocked(v, FALSE)

#define ZOOMBOX()  cmd_zoombox()       
#define ZOOMDATA() cmd_zoomdata()      
#define ZOOMDEC()  cmd_zoomdec()       
#define ZOOMFIT()  cmd_zoomfit()       
#define ZOOMIN()   cmd_zoomin()        
#define ZOOMINT()  cmd_zoomint()       
#define ZOOMOUT()  cmd_zoomout()       
#define ZOOMPREV() cmd_zoomprev()      
#define ZOOMRCL()  cmd_zoomrcl()       
#define ZOOMSQR()  cmd_zoomsqr()       
#define ZOOMSTD()  cmd_zoomstd()       
#define ZOOMSTO()  cmd_zoomsto()       
#define ZOOMTRIG() cmd_zoomtrig()      
#endif
